;PROGRAMA: NELO & QUQO by Jose J. Rodenas aka 'SEJUAN'.
;(_) RETROWORKS 2010 /06/19
        INCLUDE "DATMEN_PRE.ASM" 	;24080 previamente dejo 256bytes para la pila
					;24580 buffer de pantalla de 4096bytes=2 tercios
        INCLUDE "MARCADOR.ASM"		;28677
        INCLUDE "DATMENU.ASM"		;30982
        INCLUDE "VIQUQO.ASM"            ;32404
	ORG 32768
ESPERA
        xor a
        IN A,(#FE)
        CPL
        AND #1F
        JR Z,ESPERA
ESPERA2
        IN A,(#FE)
        CPL
        AND #1F
        JR NZ,ESPERA2

        CALL LICHAR
INI_CIO
        CALL RUBORCO
        CALL IMPMENU
        CALL RESTDAT
	XOR A
	LD (FRAME),A
	ld (FINAL),A
	CALL CARGA_CANCION
;ESPERA PULSACION DE TECLA
 LOGUAI HALT
        CALL INICIO  ;Musica en el player de wyz
        XOR A
        IN A,(#FE)
        CPL
        AND #1F
        JR Z,LOGUAI
	CALL STOP_PLAYER
        CALL RUBORCO
;COMIENZA EL JUEGO
        LD A,1
        LD (VIDAS),A
        LD (50020),A      ;CH_DIRD
        INC A
        LD (50026),A      ;SENPRO
        INC A
        LD (50005),A      ;ANCHO
        LD A,96
        LD (50003),A      ;COLU
        LD A,160
        LD (50002),A      ;FILA
        LD A,8
        LD (OFBARRA),A
        LD A,#F9          ;
        LD (BARRA),A
        LD A,#40
        LD (BARRA+1),A
        DEC A
        LD (50024),A      ;PANTA
; OBJETOS QUE LLEVAMOS
        LD DE,VEC_NUMO
        LD A,#7C
        LD (DE),A
        LD A,#C3
        INC DE
        LD (DE),A		;ACABO DE PONER LA DIRECCION 50044 EN EL VECTOR VEC_NUMO QUE ESTA EN 50049
	LD (POBNUM+1),A		;BYTE ALTO DE 50044
;IMPRESION DEL MARCADOR
        CALL EMPEZAMOS          ;EMPEZAMOS ESTA EN IMPMARCA
        XOR A
        OUT (254),A

;INICIALIZACION DE VARIABLES DE LA POSIC.DEL SPRITE
;*************************************************
;cambiadas metiendo db apartir 50002 (fila,colu,frame y ancho) meter si es necesario del mismo modo el resto
        LD DE,PROTA1
        LD A,E
        LD (POS_PRODE),A
        LD A,D
        LD (POS_PRODE+1),A
        LD DE,PROTA7
        LD A,E
        LD (POS_PROIZ),A
        LD A,D
        LD (POS_PROIZ+1),A
        XOR A        ;VACIADO DE PANTALLA INTERMEDIA
        LD HL,24580
        LD DE,24581
        LD BC,4096
        LD (HL),A
        LDIR
        LD A,56      ;CAMBIO EL COLOR A FONDO BLANCO TINTA NEGRA
        LD HL,#5900
        LD DE,#5901
        LD BC,511
        LD (HL),A
        LDIR
	LD A,#7F
        LD (POBNUM),A
	CALL LOOKEYS         ;LLAMA A SUBRUTINA TEC15B.ASM PA PINTAR ATRIB.ROJO EN PRIMER ICONO
	CALL MAPPING
	CALL SEARCH_SCR
	CALL VOL_CAR
	CALL STBLIM              ;LLAMA A LA RUTINA QUE ESTABLECE LOS LIMITES DE PANTALLA
LLAMADA CALL MOV
;#################################################################
;RUTINA DE TECLADO Y MOVIMIENTO   LOS FRAMES SE MUEVEN 2X2 PIXELS
;cambio en la idea de limites en las pantallas. Limiz y limde tendrn el limite real
;de la pantalla  LIMIZ=0 o 232 a derechas. Asi puedo tener "paredes intermedias"
TECLAS
        CALL VISUAL_ACT
        CALL BUDISCRIMEN     ;DECREMENTA TEXTDELAY SI TXTFLAG EST A 1
        CALL BUERRORMEN ;DECREMENTO EL TXTDELAY
        CALL ANTRUMOV
        CALL MOVSOLOENE

ANTECLAS:
        LD A,(OBVICON)
        AND A
;        CP 0
        JR Z,TECLANT      ;SI NO SE HA VISUALIZADO UN OBJETO CONTINUA
        CALL CLEANOBVI
        XOR A
        LD (OBVICON),A    ;BAJA EL BANDERIN Y BORRA EL OBJETO/ACCION VISUALIZADO
;FIN ANTECLAS

TECLANT:

        LD A,(VIDAS)
        AND A
        JP Z,FINJUEGO

        LD A,(FINAL)
        CP 1
        JP Z,FINALJUEGO
        LD A,#7F
        IN A,(#FE)
        CPL
        RRA              ;tecla space
        JR NC,VERM
        PUSH AF
        CALL A_SALTAR
        POP AF
        JR TECLAS
VERM    RRA              ;TECLA M
        RRA
        JR NC,VERZ
        PUSH AF
        CALL COMPACTIO
        POP AF
        JR TECLAS
VERZ    LD A,#FE
        IN A,(#FE)       ;TECLA Z
        CPL
        RRA
        RRA
        JR NC,VEROP
        PUSH AF
        CALL LOOKEYS
        POP AF
        JR TECLAS
VEROP   LD A,#DF     ;TECLAS O Y P
        IN A,(#FE)
        CPL
        RRA
        JR NC,COMTECI
        PUSH AF
        CALL A_DER
        POP AF
        JR TECLAS
COMTECI RRA
        JR NC,DIRVERT
        PUSH AF
        CALL A_IZQ
        POP AF
        JR TECLAS
DIRVERT:          ;TECLAS: Q, ARRIBA/ACCION Y A, ABAJO
        LD A,#FB
        IN A,(#FE)
        CPL
        RRA
        JR NC,VERA
        PUSH AF
        CALL A_ARRIBA
        POP AF
        JP TECLAS
VERA:
        LD A,#FD
        IN A,(#FE)
        CPL
        RRA
        JP NC,TECLAS
        PUSH AF
        CALL A_ABAJO
        POP AF
        JP TECLAS
;****************************
A_ARRIBA:
        XOR A
        LD (PUL_TEA),A
        INC A
        LD (PUL_TEQ),A
        LD (DISPBA),A        ;ESTA VARIABLE DISCRIMINA SI HAS PULSADO Q O A
        JP VERSITAB0
;        CALL VERSITAB0
;        RET

A_ABAJO:
        XOR A
        LD (PUL_TEQ),A
        LD (DISPBA),A     ;HE PULSADO LA A
        INC A
        LD (PUL_TEA),A
        JP VERSITAB0
        ;CALL VERSITAB0
        ;RET
;************************************
COMPACTIO:                           ;BUSCARA LA ACCION A REALIZAR
        LD HL,TAB_ACT
B_COPT  LD A,(PANTA)
        LD B,A
        LD A,(HL)
        CP B
        JR Z,AXCOLU
        CP 255
        JR Z,T_ERROR
        INC HL
        INC HL
        INC HL
        INC HL
        JR B_COPT
;IMPRESION DE TEXTOS DE ERROR (VER DE QUITARLOS TODOS)
T_ERROR:
        LD A,(TXERRFL)
        CP 1
        RET Z         ;SI SE HA IMPRESO ALGUN TEXTO DE ALGUNA PANTALLA NO IMPRIMAS LOS TXT DE ERROR
        LD HL,TXTERROR
        LD A,2        ;cambio el valor 6 por 2 (solo vamos a poner 2 o 3 frases DE ERROR)
        CALL RND      ;N.ALEATORIO DE FRASE
        CALL RUTXTG   ;IMPRIME LA FRASE
        LD A,1
        LD (TXERRFL),A
        JP VISUALPOPI
;        CALL VISUALPOPI
;        RET
;FIN IMPRESION DE TEXTOS DE ERROR
AXCOLU
        INC HL
        LD A,(HL)
        LD B,A
        LD A,(DIRDMOV)
        AND A
;        CP 0
        JR Z,VADCOM
        LD A,(COLU)
        ADD A,8
        CP B
        JR Z,VERSDAT
        JR VVADCOM
VADCOM  LD A,(COLU)
        CP B
        JR Z,VERSDAT
;EN EL CASO DE QUE SI SEA UNA PANTALLA CON OBJETOS PERO NO ESTES EN LA COLUMNA DESEADA
;IMPRIME UNA PISTA DE ESA PANTALLA.
VVADCOM INC HL      ;SALTO DE COMPROBAR LA COLU
        INC HL
        INC HL
;AQUI TENGO QUE DISCRIMINAR QUE TEXTOS SE IMPRIMEN A RAZON DE LA PANTALLA EN LA QUE TE ENCUENTRES
        PUSH HL
        LD A,(TXTFLAG)
        AND A
        CALL Z,DISCRIMEN    ;IMPRIME EL TEXTO SIEMPRE QUE NO HAYA UNO YA IMPRESO.
        POP HL
        JR B_COPT
VERSDAT
        INC HL     ;VAMOS A COMPROBAR QUE CLASE DE OBJETO ES
        LD A,(HL)
;        CP 1
	DEC A
        JR Z,GUAROB     ;SI CLASE =1
;        CP 2
	DEC A
        JR Z,COMPOB     ;SI CLASE =2
;        CP 3
	DEC A
;        JR Z,SXS
	RET Z
	DEC A
;        CP 4
        JR Z,CAMBIOB    ;SI CLASE =4
	DEC A
;        CP 5
        JP Z,CAMBLIMIT  ;SI CLASE =5
        CP 2
;        CP 7
        JP Z,VERFINAL   ;SI CLASE = 7
SXS     RET
GUAROB:                 ;CLASE DE OBJETO = 1
        LD DE,(VEC_NUMO)     ;VEC_NUMO ES UN VECTOR QUE APUNTA A LA DIRECCION DE NUM_OBJE ACTUAL
        LD A,E             ;COMPRUEBO SI VEC_NUMO ESTA YA EN 50049 PARA VOLVER A DEJARLO EN 50044
        CP #81
        JR NZ,SVER
        LD E,#7C           ;50044
SVER
        LD A,3
        LD (HL),A          ;ahora tengo que tostar un 3 (de accion realizada u objeto cogido)
;OJO CON ESTO YA QUE AL VOLVER A JUGAR DEBE TENER EL VALOR ANTERIOR
;SI NO SI VUELVES A EMPEZAR LA PARTIDA TENDRAS LOS DATOS DE RECOGIDA DE OBJETOS INCORRECTO.
        INC HL             ;NUMERO DE OBJETO A GUARDAR.?
        LD A,(HL)
;Se supone que DE contiene el valor num_obje donde guardar el numero de objeto encontrado
;valores de la 50044 a la 50048
        LD (DE),A          ;NUMERO DE OBJETO GUARDADO EN NUM_OBJE
        INC DE             ;DEBEMOS GUARDAR EL VECTOR NUEVO
        LD A,E
        LD (VEC_NUMO),A
        LD A,D
        LD (VEC_NUMO+1),A
        CALL IMP_ICON    ;LLAMAR A IMPRIMIR EL OBJETO
        CALL TECSELPRE      ;REIMPRIME COLOR DE ICONO
        CALL SELCOBJ
        LD HL,TASOOBJE
        LD E,1
        JP SONIDOS
;        CALL SONIDOS
;        RET
COMPOB:
;revisaremos una tabla donde comprobar si llevas el objeto para esa pantalla y esa posicion.
;GUARDAMOS LA POSICION DE HL QUE TIENE EN LA TABLA ACCION A REALIZAR
;HEMOS ENTRADO CON 2 AQUI Y SALDREMOS CON 0, ACTIVADA ESCALERA
        PUSH HL
        CALL SELCOBJ
        POP HL
        INC HL
        LD A,(HL)
        DEC HL
        LD B,A
        LD A,(INDICNUM);ESTA VARIABLE TENDR EL VALOR DEL OBJETO QUE HAY EN  LA TECLA PULSADA DEL 1 AL 5
                       ;SEALANDO QUE OBJETO QUIERES USAR EN ESTE MOMENTO PARA ESTA ACCION.
        CP B           ;SI EL OBJETO ACTIVADO ES EL QUE CORRESPONDE A ESTA POSICION Y PANTALLA

        RET NZ
;        JR NZ,NOACCION ;NO HACER LA ACCION SI NO CORRESPONDE EL OBJETO QUE LLEVAS CON LA POSICION.

        XOR A
        LD (HL),A      ;LE PONGO UN 0 EN LA TABLA PARA QUE SE ACTIVE LA ESCALERA
        INC HL
        LD (HL),A      ;LE PONGO OTRO 0 INDICANDO EL SENTIDO DE BAJADA
;AQUI TENDRE QUE LLAMAR A LA RUTINA QUE BORRE EL OBJETO DEL MENU
BORR_OVI:
        LD HL,POBNUM    ;POBNUM=VALOR DE LA TECLA PULSADA
        PUSH DE
        LD A,(HL)
        LD E,A
        INC HL
        LD A,(HL)
        LD H,A
        LD L,E
        POP DE
        XOR A
        LD (HL),A      ;LE PONGO EL 0 PARA INDICAR QUE HA SIDO USADO EL OBJETO
        CALL IMP_ICON
        JP TECSELPRE
;        CALL TECSELPRE
;        RET
;NOACCION:
;        POP HL
;        RET
CAMBIOB:
;revisaremos una tabla donde comprobar si llevas el objeto para esa pantalla y esa posicion.
;        PUSH HL        ;GUARDAMOS LA POSICION DE HL QUE TIENE EN LA TABLA ACCION A REALIZAR
        INC HL
        LD A,(HL)      ;cambiaremos 4 por 3 y pondremos el valor de la tabla accion en num_obje
        DEC HL
        LD B,A
        LD A,(INDICNUM)  ;ESTA VARIABLE TENDR EL VALOR D.OBJETO QUE HAY EN LA TECLA PULSADA DEL 1 AL 5
        CP B           ;SI EL OBJETO ACTIVADO ES EL QUE CORRESPONDE A ESTA POSICION Y PANTALLA
        RET NZ
;        JR NZ,NOCAMBI  ;NO HACER LA ACCION SI NO CORRESPONDE EL OBJETO QUE LLEVAS CON LA POSICION.(
;                       ;JR NZ,NOACCION) Y TE AHORRAS BYTES
;        POP HL         ;SI CORRESPONDE LA ACCION
        LD A,3
        LD (HL),A      ;LE PONGO UN 3 EN LA TABLA PARA QUE DESACTIVAR LA ACCION
        INC HL
        LD A,(HL)      ;GUARDO EL OBJETO DE LA POSICION 4 DE LA TAB_ACTION
        LD B,A
        CALL CHANGOBJ  ;AHORA BUSCO EL OBJETO A CAMBIAR POR ESTE
        LD A,(POBNUM)  ;RECUPERO LA DIRECCION DE NUM_OBJE QUE CONTENIA EL ANTERIOR OBJETO.
        LD L,A
        LD A,(POBNUM+1)
        LD H,A         ;HL=NUM_OBJE + EL VALOR DE INDICNUM
        LD A,B
        LD (HL),A      ;Y LO PONGO EN NUM_OBJE
;AQUI DEBO LLAMAR A LA RUTINA QUE IMPRIME LOS OBJETOS EN EL MARCADOR
        CALL IMP_ICON
        CALL TECSELPRE
        CALL SELCOBJ
        LD HL,TASOOBJE
        LD E,1
        JP SONIDOS
;        CALL SONIDOS
;        RET

;NOCAMBI:
;        POP HL
;        RET
;OPCION 5 EN LOS DATOS TAB_ACTION -CAMBIO DE LIMITES-
CAMBLIMIT:
        PUSH HL
        CALL SELCOBJ
        POP HL
        INC HL
        LD A,(HL)
        LD B,A
        LD A,(INDICNUM)
        CP B
;        JR Z,CAMBIARLIMITE
;        RET
	RET NZ
CAMBIARLIMITE:
        DEC HL            ;VUELVO A LA POSIC.PARA ANULAR LA ACCION
        LD A,3
        LD (HL),A         ;ANULO LA COMPROBACION DE LIMITE al acabar la ACCION
        LD A,(PANTA)
        LD B,A
;        LD HL,LIMPANT
	LD HL,LIMPANT-3
OTCPLI  INC HL       ;PERO LO CIERTO ES QUE SOLO VENDRE AQUI EN PANTALLAS DETERMINADAS
        INC HL       ;QUE SIEMPRE TENDRAN CORRESPONDENCIA Y NO CAUSARAN EL CUELGUE.
        INC HL
	LD A,(HL)
        CP B
        JR NZ,OTCPLI
;        JR Z,CHOOSEL ;NO COMPRUEBO SI LLEGO AL FINAL DEL FICHERO.ESTO COLGARIA LA RUTINA
;        INC HL       ;PERO LO CIERTO ES QUE SOLO VENDRE AQUI EN PANTALLAS DETERMINADAS
;        INC HL       ;QUE SIEMPRE TENDRAN CORRESPONDENCIA Y NO CAUSARAN EL CUELGUE.
;        INC HL
;        JR OTCPLI
CHOOSEL
;para saber que limite cambiar comprobar la tabla limpant, si valor izq=0 no cambiar limite
;si valor der=240 no cambiar limite. Solo cambiar limite si esos valores son distintos
        INC HL             ;valor izq = ?
        LD A,(HL)
;        CP 0
        AND A
        JR Z,VERLIDER
        XOR A
        LD (LIMIZ),A
        LD (HL),A         ;VALOR COLOCADO TAMBIEN EN LA TABLA LIMPANT
;ahora le ponemos un 1 para indicar en la tabla limites que puedes salir por ese lado de pantalla
        JR SF_LIM
VERLIDER:                 ;valor der
        INC HL
        LD A,(HL)
        CP 240
        RET Z             ;NO HAGO NADA PUESTO QUE NO HAY LIMITE A CAMBIAR
        LD A,232
        LD (LIMDE),A
        LD (HL),A
;ahora le ponemos un 1 para indicar en la tabla limites que puedes salir por ese lado de pantalla
        JR SFF_LI
SF_LIM  LD A,1
        PUSH AF
        JR SF
SFF_LI  LD A,2
        PUSH AF
SF      LD HL,LIMITES
        LD A,(PANTA)
        LD B,A
SFLI    LD A,(HL)
        CP B
        JR Z,SFFFLI
        INC HL
        INC HL
        INC HL
        JR SFLI
SFFFLI  POP AF
        ADD A,L
        LD L,A         ;YA SE EN QUE POSICION PONER EL 1
        LD A,1
        LD (HL),A      ;AHORA COMPROBAMOS SI LA PANTALLA ES LA 30.
        LD A,(PANTA)   ;SI ES LA 30 NO ABRIR EL LIMITE DE LA
        CP 30          ;PANTALLA POR LA DERECHA YA QUE NO HAY NINGUNA.
        JR NZ,NO30
        XOR A
        LD (HL),A
NO30:
        CALL PREMAGIA
        JP BORR_OVI    ;BORRAMOS EL OBJETO APROVECHANDO EL CODIGO QUE HAY AQUI.Y RETORNAMOS

VERSITAB0:
        LD HL,TAB_ACT
VE_COPT LD A,(PANTA)
        LD B,A
        LD A,(HL)
        CP B
        JR Z,AXCOLU2
        CP 255
        RET Z
        INC HL
        INC HL
        INC HL
        INC HL
        JR VE_COPT
AXCOLU2
        INC HL
        LD A,(HL)
        LD B,A
        LD A,(DIRDMOV)
;        CP 0
        AND A
        JR Z,VADCOM2
        LD A,(COLU)
        ADD A,8
        CP B
        JR Z,VERSDAT2
        JR VVADCOM2
VADCOM2 LD A,(COLU)
        CP B
        JR Z,VERSDAT2
VVADCOM2
        INC HL      ;SALTO DE COMPROBAR LA COLU
        INC HL
        INC HL
        JR VE_COPT
VERSDAT2
        INC HL     ;VAMOS A COMPROBAR QUE CLASE DE OBJETO ES
        LD A,(HL)
;        CP 0            ; SI ES 0 IR A ESCALERA
        AND A
        JR Z,ESCALERA
        CP 6
        JP Z,CAMBCALLE  ;AQUI SALTO A CAMBIO DE CRUCE
        RET
;##############################################################
ESCALERA:
;aqui miraremos si la pantalla tiene la escalera para subir o para bajar
;con otra tabla (pantalla,sube,baja)
        LD A,(DISPBA)
        OR A
        JR Z,PALABJ   ;SI VIENES DE PULSAR A VETE A CONTINUAR EN A
                      ;SI NO VE A CONTINUAR EN Q
PALARR  INC HL              ;AHORA VEMOS SI SUBE O BAJA
        LD A,(HL)
        DEC A
;        CP 1
;        JR Z,IMPFO          ;SI HAY 0 ES QUE SOLO PUEDES BAJAR
;        RET
	RET NZ
;IMPFO   XOR A
        LD (SENPRO),A
        PUSH HL    ;GUARDAMOS LA POSIC.HL EN TAB_ACT
        CALL FONDO
        POP HL
        CALL IMP_AR_ES
        CALL COMPFRAM
        JP PANTA_JUEGO
;        CALL PANTA_JUEGO
;        RET
PALABJ
        INC HL              ;AHORA VEMOS SI SUBE O BAJA
        LD A,(HL)
        AND A
;        CP 0
;        JR Z,IMPFOB         ;SOLO PODIAS SUBIR
;        RET
	RET NZ
IMPFOB  LD A,2
        LD (SENPRO),A
        PUSH HL    ;GUARDAMOS LA POSIC.HL EN TAB_ACT
        CALL FONDO
        POP HL
        CALL IMP_BA_ES
        CALL COMPFRAM
        JP PANTA_JUEGO
;        CALL PANTA_JUEGO
;        RET
;QUE FRAME TENGO QUE IMPRIMIR PROTA1 O PROTA7 ?
COMPFRAM:
        LD A,(DIRDMOV)
;        CP 0
	AND A
        JR Z,VENIADRETA
        LD DE,PROTA7
        LD A,E
        LD (POS_PROIZ),A
        LD A,D
        LD (POS_PROIZ+1),A
        RET
VENIADRETA:
        LD DE,PROTA1
        LD A,E
        LD (POS_PRODE),A
        LD A,D
        LD (POS_PRODE+1),A
        RET
;FIN ESCALERAS ################################################
;VER FINAL JUEGO
VERFINAL:
;revisaremos una tabla donde comprobar si llevas el objeto para esa pantalla y esa posicion.
        PUSH HL
        CALL SELCOBJ
        POP HL
        INC HL
        LD A,(HL)
        DEC HL
        LD B,A
        LD A,(INDICNUM);ESTA VARIABLE TENDR EL VALOR DEL OBJETO QUE HAY EN  LA TECLA PULSADA DEL 1 AL 5
                       ;SEALANDO QUE OBJETO QUIERES USAR EN ESTE MOMENTO PARA ESTA ACCION.
        CP B           ;SI EL OBJETO ACTIVADO ES EL QUE CORRESPONDE A ESTA POSICION Y PANTALLA
        RET NZ
        LD A,1
        LD (FINAL),A
;AQUI TENDRE QUE LLAMAR A LA RUTINA QUE BORRE EL OBJETO DEL MENU
	JP BORR_OVI
;        CALL BORR_OVI   ;Que est ms arriba en la parte de accion=2 COMPOB
;        RET


A_IZQ

        XOR A
        LD (CRUCE),A

CONAIZQ LD A,(COLU)           ;COMPRUEBO SI ESTOY EN EL LIMITE DE ESA PANTALLA POR LA IZQ.
        LD B,A
        LD A,(LIMIZ)
        CP B
        JR NZ,ANTSCPI
;*******************************************************
;COMPROBACION DE SALIDA POR LA IZQUIERDA DE ESA PANTALLA
        LD HL,LIMITES
LI_COPT LD A,(PANTA)
        LD B,A
        LD A,(HL)
        CP B
        JR Z,LI_CO2
        INC HL
        INC HL
        INC HL
        JR LI_COPT
LI_CO2  INC HL
        LD A,(HL)
;        CP 0                  ;COMPRUEBO SI LA PANTALLA TIENE SALIDA POR LA IZQUIERDA
        AND A
        RET Z                 ;SI NO LA TIENE DEVUELVO EL CONTROL
;SALTA A MIRAR SI HAY CRUCE
        CALL CRUZARCALLE      ;B=(PANTA)
        LD A,(CRUCE)
        AND A                 ;MIRAR SI HAY 0
        JR Z,N_CRUCE
        LD A,(V_COLU_CR)
        LD (COLU),A
        LD DE,PROTACARA
        JR CRUDECA
N_CRUCE LD A,224
        LD (COLU),A
        LD DE,PROTA7
        LD A,E
        LD (POS_PROIZ),A
        LD A,D
        LD (POS_PROIZ+1),A
        JP PANTA_JUEGO
;        CALL PANTA_JUEGO
;        RET
CRUDECA
        LD A,E
        LD (POS_PROIZ),A
        LD A,D
        LD (POS_PROIZ+1),A
        CALL PANTA_JUEGO
        CALL DELAY             ;Espero para borrar el sprite de cara
        CALL AVOLCAMIENTO
        LD DE,PROTA1
        LD A,E
        LD (POS_PRODE),A
        LD A,D
        LD (POS_PRODE+1),A
        JP MOV
;        CALL MOV
;        RET

ANTSCPI:
        LD A,3         ;SENTIDO A IZQUIERDAS
        LD (SENPRO),A
        LD A,1
        LD (DIRDMOV),A
        LD A,(CH_DIRI)
        CP 1
        JR Z,SEGUIRIZ  ;SI EL PROTA SIGUE EL MISMO SENTIDO NO COMPROBAR CAMBIO DE FRAME
        XOR A
        LD (CH_DIRD),A ;BAJO EL BANDERIN DE SENTIDO A DERECHAS Y SUBO EL DE IZQUIERDAS
        LD A,1
        LD (CH_DIRI),A
        LD DE,PROTA12
        LD A,E
        LD (POS_PROIZ),A
        LD A,D
        LD (POS_PROIZ+1),A
        CALL MOV
        LD A,(COLU)
        SUB 8
        LD (COLU),A
        RET
SEGUIRIZ:
        XOR A
        LD (FRAME),A
        LD DE,PROTA8
        LD A,E
        LD (POS_PROIZ),A
        LD A,D
        LD (POS_PROIZ+1),A
        ld c,0
        ld b,5

COIT    PUSH BC
        CALL MOVER
        LD A,(FRAME)
        INC A
        LD (FRAME),A
        POP BC
        DJNZ COIT
        XOR A
        LD (FRAME),A

	CALL VISUAL_ACT
        LD A,(LIMIZ)
        LD B,A
        LD A,(COLU)
        CP B
        RET Z             ;AQUI HA LLEGADO AL LIMITE Y EL FRAME=6, SERIA SALTAR A A_IZQ Y NO DEVOLVER EL CONTROL
;PROBABLEMENTE ANTES DEBERIAS PONER FRAME=0 PARA PODER CAMBIAR DE PANTALLA Y COLOCAR LA COLU=240
        SUB 8
        LD (COLU),A
        LD DE,PROTA7
        LD A,E
        LD (POS_PROIZ),A
        LD A,D
        LD (POS_PROIZ+1),A
        JP MOV
;        CALL MOV
;FIN     RET

A_DER
        XOR A
        LD (CRUCE),A

CONADER LD A,(COLU)
        LD B,A
        LD A,(LIMDE)
        CP B
        JR NZ,NADER

;*******************************************************
;COMPROBACION DE SALIDA POR LA DERECHA DE ESA PANTALLA
COLIMITED:
        LD HL,LIMITES
LD_COPT LD A,(PANTA)
        LD B,A
        LD A,(HL)
        CP B
        JR Z,LD_CO2
        INC HL
        INC HL
        INC HL
        JR LD_COPT
LD_CO2  INC HL
        INC HL
        LD A,(HL)
;        CP 0                  ;COMPRUEBO SI LA PANTALLA TIENE SALIDA POR LA DERECHA
        AND A
        RET Z
        LD DE,PROTA1
        LD A,E
        LD (POS_PRODE),A
        LD A,D
        LD (POS_PRODE+1),A
        LD A,8
        LD (COLU),A
        JP PANTA_JUEGO
;        CALL PANTA_JUEGO
;        RET
NADER   XOR A
        LD (DIRDMOV),A
        INC A
        LD (SENPRO),A  ;ACTIVAMOS SENTIDO A DERECHAS
        LD A,(CH_DIRD)
        CP 1
        JR Z,SEGUIRDE  ;SI EL PROTA SIGUE EL MISMO SENTIDO NO COMPROBAR CAMBIO DE FRAME
        XOR A
        LD (CH_DIRI),A ;BAJO EL BANDERIN DE SENTIDO A IZQUIERDAS Y SUBO EL DE DERECHAS
        INC A
        LD (CH_DIRD),A
        LD DE,PROTA6
        LD A,E
        LD (POS_PRODE),A
        LD A,D
        LD (POS_PRODE+1),A
        CALL MOV
        LD A,(COLU)
        ADD A,8
        LD (COLU),A
        RET
SEGUIRDE:
        XOR A        ;
        LD (FRAME),A
        LD DE,PROTA2
        LD A,E
        LD (POS_PRODE),A
        LD A,D
        LD (POS_PRODE+1),A
        LD C,0
        LD B,5
COTE    PUSH BC
        CALL MOVER
        LD A,(FRAME)
        INC A
        LD (FRAME),a
        POP BC
        DJNZ COTE

        XOR A
        LD (FRAME),A
	CALL VISUAL_ACT
        LD A,232
        LD B,A
        LD A,(COLU)
        CP B
        JP Z,COLIDERE      ;HAS LLEGADO AL LIMITE DERECHO Y FRAME = 6
        ADD A,8
        LD (COLU),A
        LD DE,PROTA1
        LD A,E
        LD (POS_PRODE),A
        LD A,D
        LD (POS_PRODE+1),A
        JP MOV
;        CALL MOV
;        RET
;###############################
; RUTINA DE LIMITES DE PANTALLA
;###############################
STBLIM:                         ;AL FINAL COMPROBAR SI ESTE RESGUARDO DE REGISTRO SE PUEDE QUITAR.
        PUSH AF
        PUSH BC
        PUSH HL
        LD HL,LIMPANT
        LD A,(PANTA)
        LD B,A
        LD A,(HL)
VSTB    CP B
        JR Z,SSTBL
        INC HL
        INC HL
        INC HL
        LD A,(HL)
        CP 255
        JR NZ,VSTB
; EN EL CASO DE QUE LLEGUES AL FINAL DE LA TABLA Y NO EXISTAN LIMITES PARA ESA PANTALLA. ESO QUIERE
;DECIR QUE ES UNA PANTALLA NORMAL DEL JUEGO. ASI QUE PONDREMOS 0,0 EN LAS VARIABLES LIMIZ Y LIMDE
        XOR A
        LD (LIMIZ),A
        LD A,232                  ;PODRIA PROBAR CON 0 PARA LOS NO LIMITES PARA PASAR  a pantalla derecha
        LD (LIMDE),A
        POP HL
        POP BC
        POP AF
        RET
SSTBL   INC HL
        LD A,(HL)
        LD (LIMIZ),A
        INC HL
        LD A,(HL)
        LD (LIMDE),A
        POP HL
        POP BC
        POP AF
        RET
;##############################################################
; FIN RUTINA QUE ESTABLECE LOS LIMITES DE LA PANTALLA DE JUEGO

PANTA_JUEGO:
        XOR A        ;VACIADO DE PANTALLA INTERMEDIA
        LD HL,24580
        LD DE,24581
        LD BC,4096
        LD (HL),A
        LDIR
INIMAP:
        CALL BDSPENPAN        ;Desactivo los sprites en pantalla
        XOR A
        LD (PRESENE),A
	CALL MAPPING
        CALL ANTRUMOV     ;llamada a rutina de mov.enemigos

;VARIANTE PARA COMPROBAR SI ESTS EN LA PANTALLA DE IDA O VUELTA EN BARCO
        LD A,(PANTA)
        CP 42
        JR NZ,SECOVUEBARCO
        CALL IDABARCO     ;IMPRIMO ANIMACION IDA BARCO
        JR INIMAP         ;SALTO OTRAVEZ AL MAPEADOR PARA QUE BUSQUE LA NUEVA PANTALLA
SECOVUEBARCO:
        CP 43
        JR NZ,SEINIMAP
        CALL VUELTABARCO
        JR INIMAP
;FIN VARIANTE PARA LA ANIMACION DEL BARCO
SEINIMAP:
	CALL SEARCH_SCR
        CALL VOL_CAR
	CALL STBLIM                   ;LLAMA A LA RUTINA QUE ESTABLECE LOS LIMITES DE PANTALLA
	JP MOV
FINJUEGO:
        CALL BDSPENPAN    ;Desactivo los sprites en pantalla  rutina contene.asm
        XOR A
        LD (PRESENE),A
       	CALL MAPPING
        CALL ANTRUMOV     ;llamada a rutina de mov.enemigos
        CALL MAPPSPRI     ;en contene.asm
        CALL BPORTAOB     ;llama a borrar inventario
        CALL RUBORCO
        CALL IMPGAMEOVER
;        JP INI_CIO
        JP ESPERA

;##############################################################
;LA_DIR_PROTA_EN_ARCH.PANTA SE GUARDA EN 50000
FILA          EQU  50002
COLU          EQU  50003
FRAME         EQU  50004
ANCHO         EQU  50005
M_PULS        EQU  50007
P_BAJO        EQU  50008
DIRDMOV       EQU  50010          ;DIRECCION DE MOVIMIENTO 0 DER. 1 IZQ. 2 SALTO DER. 3 SALTO IZQ.
PUL_TEQ       EQU  50012
POS_PRODE     EQU  50014
POS_PROIZ     EQU  50016
PUL_TEA       EQU  50018
CH_DIRD       EQU  50020
CH_DIRI       EQU  50022
PANTA         EQU  50024
SENPRO        EQU  50026
LAST_SE       EQU  50028
VEC_TILE      EQU  50030
ALT_TILE      EQU  50032
ANCH_TILE     EQU  50034
FIL_DAT       EQU  50036
COL_DAT       EQU  50038
POTI_IMP      EQU  50040
POAP_BUF      EQU  50042
NUM_OBJE      EQU  50044          ;HASTA 50048 PARA CADA UNO DE LOS OBJETOS
VEC_NUMO      EQU  50049
LIMIZ         EQU  50051          ;LIMITE DE LA PANTALLA POR EL LADO IZQUIERDO
LIMDE         EQU  50052          ;IDEM POR EL DERECHO. AMBOS DATOS LOS SACA DE TABLIMI.ASM
INDICNUM      EQU  50053          ;INDICE DE LOS OBJETOS QUE LLEVAS.
TXERRFL       EQU  50054          ;BANDERIN DE CONDICION DE TEXTO ERRONEO IMPRESO.
TXTFLAG       EQU  50055          ;BANDERIN DE CONDICION DE TEXTO IMPRESO.
POBNUM        EQU  50056          ;GUARDA EL VALOR DE LA TECLA PULSADA (50044 A 50048)
DISPBA        EQU  50058
OBVICON       EQU  50060          ;VAR.QUE INDICA SI SE HA VISUALIZADO UN LUGAR CON ACCION A REALIZAR
VALORDICO     EQU  50062          ;VAR.QUE AYUDA PARA IMPRIMIR LA COLUMNA DEL TILE EN EL ICONO
TEXTDELAY     EQU  50064
CRUCE         EQU  50066          ;VAR.PARA SABER SI CRUZAS UNA CALLE
V_COLU_CR     EQU  50068          ;VAR.PARA VOLCAR EN COLU AL CRUZAR UNA CALLE
TERRDELAY     EQU  50070
VIDAS         EQU  50072
OFBARRA       EQU  50073
BARRA         EQU  50074
;valores para enemigos
DIR_SP        EQU  50100         ;valor en arch.pant.enem.activo y colisiones
PANTSPRI      EQU  50102
SENSPRI       EQU  50104
V_PANTSPRI    EQU  50106
FILA_SP       EQU  50108
COLU_SP       EQU  50110
ALT_SP        EQU  50112
VOL_SP        EQU  50114
DATSPR        EQU  50116
PRESENE       EQU  50118
FRAMSP        EQU  50120
V_FRSP        EQU  50122
COLUMAG       EQU  50124
VARCHOQE      EQU  50126
FINAL         EQU  50128
        INCLUDE  "LETRAS.ASM"       ; 34148 PUEDES TRASLADAR ESTA RUTINA AL FINAL Y QUITAR LOS LDIR
        INCLUDE  "IMPIX.ASM"        ; 34379 QUE DUPLICAN LOS DB'S DE LAS LETRAS PERO CAMBIA TAMBIEN
        INCLUDE  "VOLCAMIENTO.ASM"  ; 34461 LA RUTINA EN RUTEXT.ASM EL VALOR DE BC AL QUE TENDRA HL
        INCLUDE  "METALIMPROTA.ASM" ; 34516
        INCLUDE  "CALCDIRBUFF.ASM"  ; 34601
        INCLUDE  "VOLCAR.ASM"       ; 34625
        INCLUDE  "BUPAIM.ASM"       ; 34720
        INCLUDE  "C_TILEDIRBUFF.ASM" ;34835
        INCLUDE  "INYECTILE.ASM"    ; 34893
        INCLUDE  "RNDRUT.ASM"       ; 34931
        INCLUDE  "RUTEXT.ASM"       ; 34974
        INCLUDE  "TEC15B.ASM"       ; 35032
        INCLUDE  "IMPMARCA.ASM"     ; 35152
        INCLUDE  "FONDO.ASM"        ; 35249
        INCLUDE  "IMPBASU2.ASM"     ; 35292
        INCLUDE  "ANIMAESC.ASM"     ; 35422
        INCLUDE  "RUBORPA.ASM"      ; 35638
        INCLUDE  "IMPMENU.ASM"      ; 35651
        INCLUDE  "CHANGOB.ASM"      ; 35744
        INCLUDE  "IMPICONOS.ASM"    ; 35762
        INCLUDE  "CAMBPANT.ASM"     ; 35922
        INCLUDE  "MAPEADOR.ASM"     ; 36051
        INCLUDE  "TECSEL.ASM"       ; 36252
        INCLUDE  "VISOBJ.ASM"       ; 36292
        INCLUDE  "RUTDISCMENSAJES.ASM" ;36757
	INCLUDE  "SALTO.ASM"        ; 36912
        INCLUDE  "ANIMABARCO.ASM"   ; 37677
        INCLUDE  "VOLCAMIENTOSPX.ASM" ; 38398
        INCLUDE  "POPI.ASM"         ; 38522
        INCLUDE  "RUTERRORMENSAJES.ASM" ; 38634
        INCLUDE  "CAMBMAGIA.ASM"    ; 38697
        INCLUDE  "BORRPORTAOB.ASM"  ; 38771 termina en 38788 borro objetos de inventario
        INCLUDE  "TEXTCOMAS.ASM"
        ;libres 123 bytes
        INCLUDE  "TABENEM.ASM"      ; 38912 fijado en esa direccion
        INCLUDE  "IMPENEY.ASM"      ; 39190 FICHERO DE IMPRESION DE SPRITES ENEMIGOS
        INCLUDE  "PINTENE.ASM"      ; 39251
        INCLUDE  "CONTENE.ASM"      ; 39668
        INCLUDE  "IMPMAGIA.ASM"     ; 39723
        INCLUDE  "DETCHOQUES.ASM"   ; 39844
        INCLUDE  "RESTAVIDAS.ASM"   ; 39934
        INCLUDE  "RUSONIMUER.ASM"   ; 39856 TERMINA JUSTO EN 39985 NO TOCAR NADA.
        INCLUDE  "DATAS_PANT.ASM"   ; 40000
        INCLUDE  "MOVERSPR.ASM"   ;NO CAMBIAR NADA DE ESTAS RUTINAS HASTA TABACTION.ASM
        INCLUDE  "MANESP.ASM"     ;MANEJO DE SPRITES ENEMIGOS. SI LA CAMBIAS CAMBIAR
        INCLUDE  "DATMAGIA.ASM"   ;LA RUTINA RESTAURARDATAS.ASM
        INCLUDE  "BARRAENERGIA.ASM"
        INCLUDE  "RESTAURARDATAS.ASM"  ;LA RUTINA NO ES REUBICABLE Y DEBE IR ACOMPAADA
        INCLUDE  "TABACTION.ASM"  ;DE ESTA por ello lo de MANESP.ASM
        INCLUDE  "DATAS_OBJEVI.ASM" ;termina en 49777
        INCLUDE  "RUFINAL.ASM"      ; 49778 termina en 49934
        ;libres 66 bytes hasta 49999
        INCLUDE  "DATENEMI1.ASM"  ; APARTIR DE 50200
        INCLUDE  "PROANDA.ASM"    ; APARTIR DE LA 52000 tambien llamado nuevoproanda
        INCLUDE  "PROSALTA.ASM"   ; es nuevoprosalta
        INCLUDE  "DATAS_DECO.ASM" ;
        INCLUDE  "TABPANTAS.ASM"  ; 57664 PARA UNAS 40 PANTALLAS SOBRA A 2 POR PANTALLA
        INCLUDE  "DATENEMI2.ASM"  ; Guardiacivil 57748 no tocar para nada
        INCLUDE  "FINALJUEGO.ASM" ; 59476 no tocar de aqui
        INCLUDE  "TABLIMI2V.ASM"  ; 60376 y esta mucho menos
        INCLUDE  "RUSONISAL.ASM"  ; 60577
        INCLUDE  "PLAY37A.ASM"    ;Player by WYZ
                                  ;dessenrollar aqui la msica 3900BYTES + -
                                  ;LETRAS PROPIAS EN 64520 + 208 BYTES.
        INCLUDE  "TEXTOSFINAL.ASM";TERMINA EN 64793
        INCLUDE  "MAKIMUE.ASM"    ; libres 205 bytes
        INCLUDE  "TEXTOS.ASM"     ;65000