; Rutina que visualiza un icono en el marcador al pasar por delante
VISUAL_ACT:
;************************************
;BUSCARA LA ACCION A REALIZAR
        EXX                  ;GUARDO LOS VALORES BC,DE,HL
        LD HL,TAB_ACT
VBB_COPT:
        LD A,(PANTA)
        LD B,A
        LD A,(HL)
        CP B
        JR Z,VBAXCOL
        CP 255
        JR Z,SLVB
        INC HL
        INC HL
        INC HL
        INC HL
        JR VBB_COPT

VBAXCOL INC HL
        LD A,(HL)
        LD B,A
        LD A,(DIRDMOV)
        AND A
        JR Z,VBVADCOM
        LD A,(COLU)
        ADD A,8
        CP B
        JR Z,VBVERSDAT
        JR VBVVADCOM
VBVADCOM:
        LD A,(COLU)
        CP B
        JR Z,VBVERSDAT
VBVVADCOM:
	INC HL      ;SALTO DE COMPROBAR LA COLU
        INC HL
        INC HL
        JR VBB_COPT
VBVERSDAT:
        INC HL     ;VAMOS A COMPROBAR QUE CLASE DE OBJETO ES
        LD A,(HL)
        CP 3
        JR Z,SLVB		;DEVOLVER EL CONTROL SI YA SE HA REALIZADO LA ACCION
	CP 6
	JR Z,VICALLE	;VISUALIZAR SENYALIZACION DE CALLE
        AND A
	JR Z,VIESCA	;VISUALIZAR ESCALERA  Si= 0
;EN CASO CONTRARIO VISUALIZAR ICONO DE OBJETO ESCONDIDO O ACCION ESCONDIDA
        LD DE,OBJ_HERRAM      ;OBJETOS DE 3X3
OBVIO   LD A,24
        LD (ALT_TILE),A
        LD A,3
        LD (ANCH_TILE),A
        DEC A
        LD B,A             ;FILA 2
        LD (FIL_DAT),A
        DEC A
        LD C,A             ;COLUMNA 1
        LD (COL_DAT),A
        CALL IM_CHAR
        CALL IMPRMAR
        LD A,1
        LD (OBVICON),A
SLVB    EXX                ;RESTAURO LOS VALORES BC,DE,HL
        RET

VIESCA
        LD DE,OBJ_ESCALA      ;OBJETOS DE 3X3
        JR OBVIO
VICALLE
        LD DE,OBJ_POSTE      ;OBJETOS DE 3X3
        JR OBVIO
CLEANOBVI:
        LD DE,OBJ_VACIO      ;OBJETOS DE 3X3
        LD A,24
        LD (ALT_TILE),A
        LD A,3
        LD (ANCH_TILE),A
        DEC A
        LD B,A             ;FILA 2
        LD (FIL_DAT),A
        DEC A
        LD C,A             ;COLUMNA 1
        LD (COL_DAT),A
        CALL IM_CHAR
        CALL IMPRMAR
        RET
OBJ_ESCALA

	DEFB	 66,  0,  0
	DEFB	 67,  0,  0
	DEFB	111,  0,  0
	DEFB	189,  0,  0
	DEFB	113,128,  0
	DEFB	177,128,  0
	DEFB	115,128,  0
	DEFB	159,128,  0

	DEFB	 92,192,  0
	DEFB	184,192,  0
	DEFB	 76,192,  0
	DEFB	141,192,  0
	DEFB	 95, 96,  0
	DEFB	174, 32,  0
	DEFB	 70, 48,  0
	DEFB	134,240,  0

	DEFB	 87,240,  0
	DEFB	175, 24,  0
	DEFB	 67, 24,  0
	DEFB	139,120,  0
	DEFB	 67,248,  0
	DEFB	171,140,  0
	DEFB	 81,140,  0
	DEFB	137,128,  0
;atrib
	DEFB	 16,16,16
	DEFB	 16,16,16
	DEFB	 16,16,16

OBJ_HERRAM
	DEFB	  8,  0,  0
	DEFB	  0,  0,  0
	DEFB	  8,  0,  0
	DEFB	  8, 97,128
	DEFB	 60,166,128
	DEFB	192,108,128
	DEFB	128, 19,  0
	DEFB	129,251,192

	DEFB	 97,235,192
	DEFB	  1,235,192
	DEFB	  1,235,192
	DEFB	  2, 40, 32
	DEFB	  1,239,192
	DEFB	  0, 56,  0
	DEFB	  1,235,192
	DEFB	  1,235,192

	DEFB	  1,235,206
	DEFB	  0, 16, 17
	DEFB	  0,  0,  1
	DEFB	  0,  0,  2
	DEFB	  0,  0,  4
	DEFB	  0,  0,  4
	DEFB	  0,  0,  0
	DEFB	  0,  0,  4
; (Attributes here, insert label if needed)
	DEFB	 16,16,16
	DEFB	 16,16,16
	DEFB	 16,16,16

OBJ_POSTE
	DEFB	  0, 12,  0
	DEFB	  1,255,192
	DEFB	  1, 26, 64
	DEFB	  1,169, 64
	DEFB	  0, 72,128
	DEFB	  0,136, 64
	DEFB	  1,  4, 32
	DEFB	  2,146, 32

	DEFB	  5, 45,224
	DEFB	 10, 76,  0
	DEFB	  8,140,  0
	DEFB	  9, 12,  0
	DEFB	 14, 12,  0
	DEFB	  0,  4,  0
	DEFB	  0,  6,  0
	DEFB	  0,  6,  0

	DEFB	  0,  6,  0
	DEFB	  0,  6,  0
	DEFB	  0,  6,  0
	DEFB	  0, 12,  0
	DEFB	  0, 12,  0
	DEFB	  0, 12,  0
	DEFB	  0, 12,  0
	DEFB	  0, 12,  0
; (Attributes here, insert label if needed)
	DEFB	 16,16,16
	DEFB	 16,16,16
	DEFB	 16,16,16

OBJ_VACIO

	DEFB	  0,0,0
	DEFB	  0,0,0
	DEFB	  0,0,0
	DEFB	  0,0,0
	DEFB	  0,0,0
	DEFB	  0,0,0
	DEFB	  0,0,0
	DEFB	  0,0,0

	DEFB	  0,0,0
	DEFB	  0,0,0
	DEFB	  0,0,0
	DEFB	  0,0,0
	DEFB	  0,0,0
	DEFB	  0
OBJ_VACICO               ;ME VALE PARA NO TENER QUE DUPLICAR EL VACIAR LOS ICONOS PEQUEOS.
        DEFB      0,0
	DEFB	  0,0,0
	DEFB	  0,0,0

	DEFB	  0,0,0
	DEFB	  0,0,0
	DEFB	  0,0,0
	DEFB	  0,0,0
	DEFB	  0,0,0
	DEFB	  0,0,0
	DEFB	  0,0,0
	DEFB	  0,0,0
; (Attributes here, insert label if needed)
        DEFB  56,56,56      
        DEFB  56,56,56
        DEFB  56,56,56
