;#######################
;  RUTINA DE MAPEADO
;#######################
; En la llamada a esta rutina traeremos una variable para saber en que posicion estaba el prota, osea el limite
; de pantalla al que ha llegado. ARRIBA,DER,ABAJO,IZQ. (0,1,2,3). Vamos a 'crear' un byte con la informacin
; suficiente que necesita un offset en una tabla.
; Para la direccin a la que va a ir tomamos el bit 7 y 6 (valores 00 01 10 11) usea arriba,der,abajo,izq
; Para el nmero de pantalla el resto de bits de la variable PANTA (mximo de pantallas 64)
; La variable que sabe el sentido del prota la llamamos SENPRO.
MAPPING
            LD A,(PANTA)
            LD (LAST_SE),A  ; GUARDO EL VALOR ACTUAL DE PANTA PARA USARLO SI MUERO.
            LD B,A
            LD A,(SENPRO)
            RRCA
            RRCA          ;TENGO EL VALOR EN LOS BITS 7 Y 6
            OR B          ;ACABO DE METER PANTA JUNTO A SENPRO
            LD B,A
            LD DE,TABSEN  ;TABLA CON 64X4 = 256  POSIBLES DIRECCIONES
SALTARIN    LD A,(DE)
            CP B
            JR Z,SALTAB
            INC DE        ;COMPROBAMOS EL SIGUIENTE
            INC DE
            JR SALTARIN   ;OJO COMO TE EQUIVOQUES Y NO ENCUENTRE NADA SE CUELGA AQUI.
SALTAB      INC DE
            LD A,(DE)     ;NUEVO VALOR DE LA VARIABLE PANTA
            LD (PANTA),A  ;AL ENCONTRAR LA CORRESPONDENCIA ENCUENTRAS LA PANTALLA A LA QUE QUIERES IR.
            RET
;#########################
;  FIN RUTINA DE MAPEADO
;#########################
;TABLA DE DIRECCIONES DE SALIDA DE PANTALLA. MAPEADO
TABSEN      DEFB %10111111,0    ;            DEFB %00000000,0   SENPRO=2 panta=63
            DEFB %10000000,1    ; abajo a panta=1 bodega del bar
            DEFB %01000000,2    ; a la derecha salimos del bar
            DEFB %00000000,3    ;PANTALLA 1 CRUCE CALLE 1
            DEFB %00000001,0    ;DEL SOTANO PARRIBA
            DEFB %11000010,0    ;CALLE PATRICIO PEREZ
            DEFB %01000010,12   ;CONTINUA P.PEREZ HACIA EL PUERTO
            DEFB %11000011,0    ;VUELTA A LA PANTALLA DEL BAR.CRUCE 1
            DEFB %01000011,4    ;PANTALLA DE LA IGLESIA
            DEFB %00000100,8    ;DE LA IGLESIA CRUCE A LA CRIPTA
            DEFB %01000100,5    ;INMEDIACIONES CUARTEL G.CIVIL
            DEFB %11000100,3
            DEFB %11000101,4
            DEFB %01000101,6
            DEFB %11000110,5
            DEFB %01000110,7    ;ENTRADA CUARTEL G.CIVIL
            DEFB %00000111,11   ;C.G.CIVIL
            DEFB %11000111,6
            DEFB %01001000,9    ;HACIA LA CRIPTA
            DEFB %11001000,4    ;CRUCE DE LA IGLESIA
            DEFB %00001001,10   ;EN LA CRIPTA
            DEFB %11001001,8
            DEFB %11001010,9    ;VUELTA DE LA CRIPTA
            DEFB %11001011,7    ;VUELTA DESDE C.G.CIVIL
            DEFB %01001100,13   ;PANTALLA 12 A 13 DE PATRICIP PEREZ
            DEFB %11001100,2    ;A PANTALLA 12 VUELVE A 2 DE PATRICIO PEREZ
	    DEFB %01001101,14	;13 A 14
	    DEFB %11001101,12	;13 A 12
            DEFB %00001110,22	;14 A 22 CALLE QUE CRUZA
	    DEFB %01001110,15	;14 A 15
	    DEFB %11001110,13	;14 A 13
	    DEFB %11001111,14	;15 A 14
            DEFB %01001111,16   ;15 A 16
            DEFB %11010000,15   ;16 A 15

	    DEFB %01010000,42   ;16 A 42    ;A visualizar animacion ida barca
	    DEFB %01101010,32   ;42 A 32    ;A NEW TABARCA

            DEFB %10010000,17   ;16 A 17
            DEFB %00010001,16   ;17 A 16
            DEFB %11010001,18   ;17 A 18
            DEFB %01010010,17   ;18 A 17
            DEFB %11010010,19   ;18 A 19
            DEFB %01010011,18   ;19 A 18
            DEFB %11010011,20   ;19 A 20
            DEFB %01010100,19   ;20 A 19
            DEFB %11010100,21   ;20 A 21
            DEFB %01010101,20   ;21 A 20
;DEFB %11010101,X       ;DE LA 21 A LA DEL HUEVO
            DEFB %01010110,23   ;22 A 23
            DEFB %11010110,14   ;22 A 14
            DEFB %01010111,24   ;23 A 24
            DEFB %11010111,22   ;23 A 22
            DEFB %00011000,27   ;24 A 27  CALLE DEL BANCO
            DEFB %01011000,25   ;24 A 25
            DEFB %11011000,23   ;24 A 23
            DEFB %01011001,26   ;25 A 26
            DEFB %11011001,24   ;25 A 24
            DEFB %00011010,29   ;26 A 29   CASONA
            DEFB %11011010,25   ;26 A 25
            DEFB %11011101,26   ;29 A 26
            DEFB %00011011,31   ;27 A 31  CALLEJON
            DEFB %11011011,24   ;27 A 24
            DEFB %01011011,28   ;27 A 28
            DEFB %00011100,30   ;28 A 30 BANCO'JONES
            DEFB %11011100,27   ;28 A 27
            DEFB %11011110,28   ;30 A 28
            DEFB %11011111,27   ;31 A 27

	    DEFB %11100000,43	;32 A 43 animacion VUELTA de la barca
	    DEFB %11101011,16	;32 A 16 VUELTA A TIERRA 

	    DEFB %01100000,33	;32 A 33
	    DEFB %11100001,32	;33 A 32
	    DEFB %01100001,34	;33 A 34
 	    DEFB %11100010,33	;34 A 33
	    DEFB %10100010,35	;34 A 35 ALMACEN SUBTERR.EN TABARCA
	    DEFB %01100010,36	;34 A 36
	    DEFB %00100011,34	;35 A 34 SUBE DE ALMACEN
	    DEFB %11100100,34	;36 A 34
	    DEFB %01100100,37	;36 A 37
	    DEFB %00100100,39	;36 A 39 CRUCE EN TABARCA
	    DEFB %11100101,36	;37 A 36
	    DEFB %01100101,38	;37 A 38
	    DEFB %11100110,37	;38 A 37
	    DEFB %11100111,36	;39 A 36 SALE CRUCE EN TABARCA
	    DEFB %01100111,40	;39 A 40
	    DEFB %11101000,39	;40 A 39
	    DEFB %01101000,41	;40 A 41
	    DEFB %11101001,40	;41 A 40
